Public Class Form1
    ' Factor the number.
    Private Sub btnFactor_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFactor.Click
        ' Get the number's factors.
        Dim num As Long = Long.Parse(txtNumber.Text)
        Dim factors As List(Of Long) = FindFactors(num)

        ' Validate the result (for bug-proofing).
        Dim result As Long = 1
        For Each factor As Long In factors
            result *= factor
        Next factor
        Debug.Assert(result = num)

        ' Display the factors.
        txtFactors.Text = FactorsToString(factors)
    End Sub

    ' Return the number's prime factors.
    Private Function FindFactors(ByVal num As Long) As List(Of Long)
        Dim result As List(Of Long) = New List(Of Long)()

        ' Take out the 2s.
        Do While (num Mod 2 = 0)
            result.Add(2)
            num \= 2
        Loop

        ' Take out other primes.
        Dim factor As Long = 3
        Do While (factor * factor <= num)
            If (num Mod factor = 0) Then
                ' This is a factor.
                result.Add(factor)
                num \= factor
            Else
                ' Go to the next odd number.
                factor += 2
            End If
        Loop

        ' If num is not 1, then whatever is left is prime.
        If (num > 1) Then result.Add(num)

        Return result
    End Function

    ' Return a string like "2 x 3 x 5".
    Private Function FactorsToString(ByVal factors As List(Of Long)) As String
        Dim result As String = ""
        For Each factor As Long In factors
            result &= " x " & factor.ToString()
        Next factor

        ' Remove the initial " x ".
        Return result.Substring(3)
    End Function
End Class
